----------------------------------------------------------------------------------
-- Company: FRI
-- Engineer: Miha Moskon
-- 
-- Create Date:    08:22:05 10/05/2007 
-- Design Name: 
-- Module Name:    btn_pressed - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity btn_pressed is
	port (
		CLK_in	: in	STD_LOGIC;
		RST_in	: in	STD_LOGIC;
		BTN_in	: in	STD_LOGIC;
		SIG_out	: out	STD_LOGIC);
end btn_pressed;

architecture Behavioral of btn_pressed is
	type STATES is (S1, S2);
	signal currSt, nextSt	:	STATES;
	
	signal output	: STD_LOGIC;
begin

	SIG_out	<= output;

	
	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
			if (RST_in = '1') then
				currSt	<=	S1;
			else
				currSt	<= nextSt;		
			end if;	
		end if;	
	end process;
	
	-- Mealyjev avtomat
	process (BTN_in, currSt)
	begin
		case currSt is
			when S1	=>
				if (BTN_in = '0') then
					nextSt	<= S1;
					output	<= '0';
				else
					nextSt	<= S2;
					output	<= '0';
				end if;
			
			when S2	=>
				if (BTN_in = '0')	then
					nextSt	<= S1;
					output	<= '1';
				else
					nextSt	<= S2;
					output	<= '0';
				end if;
		end case;
	end process;



end Behavioral;

